
OCE = {} --A convenient way to store all of the information the window/dialog creates.
--local cfg = wx.wxConfigBase.Get()
-- local a
-- local path
--   a,path = cfg:Read("/RecentFiles/Material/Path")
-- getPath=function(str,sep)
--   sep=sep or'/'
--    return str:match("(.*"..sep..")")
-- end
--   y = path
--   pathO = (getPath(y,"\\")).."\\OperationCost.INI"
 --local PATH =  sc.GetMyPath() .. "\\Files\\OperationCost.INI"
local path = wx.wxStandardPaths.Get():GetUserDataDir() .. "/SCJobCosting"
wx.wxMkdir(path)
PATH1 = path  .. "\\OperationCost.INI" 
-- create Operational Cost TableDialog
OCE.m_MaterialCostDialog = wx.wxDialog (wx.NULL, wx.wxID_ANY, "Operational Costs", wx.wxDefaultPosition, wx.wxDefaultSize, wx.wxDEFAULT_DIALOG_STYLE )--create and name the window with desired settings
	OCE.m_MaterialCostDialog:SetSizeHints( wx.wxDefaultSize, wx.wxDefaultSize )
	
	OCE.bSizer4 = wx.wxBoxSizer( wx.wxVERTICAL )--create a sizer to place elements in
	
	OCE.m_MaterialCostGrid = wx.wxGrid( OCE.m_MaterialCostDialog, wx.wxID_ANY, wx.wxDefaultPosition, wx.wxDefaultSize, 0 )
	
	-------------------------GRID SETTINGS------------------------------------------
	-- Grid
	OCE.m_MaterialCostGrid:CreateGrid( 1, 4 )
	OCE.m_MaterialCostGrid:EnableDragGridSize( False )
	OCE.m_MaterialCostGrid:SetMargins( 0, 0 )
	
	-- Columns
	OCE.m_MaterialCostGrid:SetColSize( 0, 100 )
	OCE.m_MaterialCostGrid:SetColSize( 1, 100 )
	OCE.m_MaterialCostGrid:SetColSize( 2, 100 )
	OCE.m_MaterialCostGrid:SetColSize( 3, 100 )
	
	OCE.m_MaterialCostGrid:EnableDragColSize( True )
	OCE.m_MaterialCostGrid:SetColLabelSize( 30 )
	OCE.m_MaterialCostGrid:SetColLabelAlignment( wx.wxALIGN_CENTRE, wx.wxALIGN_CENTRE )
	
	-- Rows
	OCE.m_MaterialCostGrid:AutoSizeRows()
	OCE.m_MaterialCostGrid:EnableDragRowSize( True )
	OCE.m_MaterialCostGrid:SetRowLabelSize( 80 )
	OCE.m_MaterialCostGrid:SetRowLabelAlignment( wx.wxALIGN_CENTRE, wx.wxALIGN_CENTRE )
	
	-- Label Appearance
	
	-- Cell Defaults
	OCE.m_MaterialCostGrid:SetDefaultCellAlignment( wx.wxALIGN_LEFT, wx.wxALIGN_TOP )
	OCE.m_MaterialCostGrid:SetMinSize( wx.wxSize( 500,100 ) )
	OCE.m_MaterialCostGrid:SetMaxSize( wx.wxSize( -1,750 ) )
	-------------------------END GRID SETTINGS------------------------------------------
	
	OCE.bSizer4:Add( OCE.m_MaterialCostGrid, 0, wx.wxALL + wx.wxALIGN_CENTER_HORIZONTAL, 5 )
	
	OCE.m_sdbSizer2 = wx.wxStdDialogButtonSizer()
	OCE.m_sdbSizer2OK = wx.wxButton( OCE.m_MaterialCostDialog, wx.wxID_OK, "" )--Add an "OK" button to the bottom of the dialog.
	OCE.m_sdbSizer2:AddButton( OCE.m_sdbSizer2OK )
	OCE.m_sdbSizer2:Realize();
	
	OCE.bSizer4:Add( OCE.m_sdbSizer2, 1, wx.wxALIGN_CENTER_HORIZONTAL, 5 )
	
	
	OCE.m_MaterialCostDialog:SetSizer( OCE.bSizer4 )
	OCE.m_MaterialCostDialog:Layout()
	OCE.bSizer4:Fit( OCE.m_MaterialCostDialog )
	
	OCE.m_MaterialCostDialog:Centre( wx.wxBOTH )
	
	-- Connect Events
lastrow = 0
lastcol = 0


	OCE.m_MaterialCostGrid:Connect( wx.wxEVT_GRID_CELL_CHANGE, function(event) --This is an event handler that happens when the user changes data in a cell.
		row = event:GetRow()
        col = event:GetCol()
        event:Skip()
		toolnum = 1 --row+1; --since tooling starts at tool 1 and row starts at 0, we have to add 1 to the row to get the correct tool.
		if(col == 0) then --update the MachineCost
			MachCost =(OCE.m_MaterialCostGrid:GetCellValue(row, col))
          --PATH1 = path  .. "\\OperationCost.INI"
            settings = wx.wxFileConfig("","",PATH1,"",wx.wxCONFIG_USE_LOCAL_FILE)
            settings:SetPath("OPcost")
            --to write a value
            settings:Write("Machine",MachCost)
            settings:Flush()

		elseif(col == 1) then --update the PrepCost
      
			PrepCost =(OCE.m_MaterialCostGrid:GetCellValue(row, col))
         --local PATH = pathO  --sc.GetMyPath().."\\Files\\OperationCost.INI"
            settings = wx.wxFileConfig("","",PATH1,"",wx.wxCONFIG_USE_LOCAL_FILE)
            settings:SetPath("OPcost")
            --to write a value
            settings:Write("Prep",PrepCost)
            settings:Flush()
            
		elseif(col == 2) then --update the PaintCost
			
         PaintCost=(OCE.m_MaterialCostGrid:GetCellValue(row, col))
         --local PATH3 = pathO --sc.GetMyPath().."\\Files\\OperationCost.INI"
            settings = wx.wxFileConfig("","",PATH1,"",wx.wxCONFIG_USE_LOCAL_FILE)
            settings:SetPath("OPcost")
            --to write a value
            settings:Write("Paint",PaintCost)
            settings:Flush()
            
		elseif(col == 3) then --update the PierceCost
			
         PierceCost =(OCE.m_MaterialCostGrid:GetCellValue(row, col))
         --local PATH4 = pathO --sc.GetMyPath().."\\Files\\OperationCost.INI"
            settings = wx.wxFileConfig("","",PATH1,"",wx.wxCONFIG_USE_LOCAL_FILE)
            settings:SetPath("OPcost")
            --to write a value
            settings:Write("Pierce",PierceCost)
            settings:Flush()
		end
	end )
	
	OCE.m_MaterialCostGrid:Connect( wx.wxEVT_GRID_CELL_LEFT_CLICK, function(event) --This is an event handler that happens when the user clicks in a cell.
		local rownum = event:GetRow()
        local colnum = event:GetCol()
        if(lastrow ~= rownum or lastcol ~= colnum) then
            OCE.m_MaterialCostGrid:SetCellBackgroundColour(tonumber(rownum), tonumber(colnum), wx.wxColour(wx.wxGREEN))--This code changes the new cell to green
            OCE.m_MaterialCostGrid:SetCellBackgroundColour(tonumber(lastrow), tonumber(lastcol), wx.wxColour(wx.wxWHITE))--This cell changes the old green cell to white.
            lastrow = rownum
            lastcol = colnum
            OCE.m_MaterialCostGrid:ForceRefresh()
        end
        event:Skip()
	end )
	
    function OCE.SetupToolTable()
        OCE.m_MaterialCostGrid:SetColLabelValue(0, "MachineCost")--Set the labels for the columns
        OCE.m_MaterialCostGrid:SetColLabelValue(1, "PrepCostCost")
        OCE.m_MaterialCostGrid:SetColLabelValue(2, "PaintCost")
        OCE.m_MaterialCostGrid:SetColLabelValue(3, "PierceCost")
        
        
        
        
        --local PATH2 = path .. "\\OperationCost.INI"

settings = wx.wxFileConfig("","",PATH1,"",wx.wxCONFIG_USE_LOCAL_FILE)

--to read a value:

settings:SetPath("OPcost")

a,MaCost = settings:Read("Machine")
a,PrCost = settings:Read("Prep")
a,PaCost = settings:Read("Paint")
a,PiCost = settings:Read("Pierce")

MachCost = MaCost
PrepCost = PrCost
PaintCost = PaCost
PierceCost = PiCost
       
		
        local maxnumtools = 1
        local numcols = 4
        for i = 0, maxnumtools do --Loop through the rows
            for j = 0, numcols do --Loop through the columns
				local toolnum = i+1
                local returndouble
                local returnstring
                if(j == 0) then --If we are in the first column, then we get the Machine Cost and set it to the cell we are in ->(i,j)
                    returndouble = MachCost 
                    OCE.m_MaterialCostGrid:SetCellValue(i,j, tostring(returndouble))

                elseif(j == 1) then--If we are in the second column, then we get the PrepCost and set it to the cell we are in ->(i,j)
                    returndouble = PrepCost 
                    OCE.m_MaterialCostGrid:SetCellValue(i,j, tostring(returndouble))

                elseif(j == 2) then--If we are in the third column, then we get the PaintCost and set it to the cell we are in ->(i,j)
                    returndouble = PaintCost 
                    OCE.m_MaterialCostGrid:SetCellValue(i,j, tostring(returndouble))

                elseif(j == 3) then--If we are in the fourth column, then we get the PierceCost and set it to the cell we are in ->(i,j)
                    returndouble = PierceCost 
                    OCE.m_MaterialCostGrid:SetCellValue(i,j, tostring(returndouble))
                
                end
            end
        end
    end
 

function OCE.Show()
OCE.SetupToolTable()
OCE.m_MaterialCostDialog:ShowModal()
mainframe:Raise()

 end   


