-----------------------------------------------------------------------------
-- Name:        SheetCam Job Costing
-- Author:      T Parker / SheetCam Author: Les Newell
-- Modified by:
-- Created:     02/18/2015


-- Licence:     SheetCam License
-----------------------------------------------------------------------------
local cfg = wx.wxConfigBase.Get()
local a
 local path
   a,path = cfg:Read("/RecentFiles/Material/Path")
 getPath=function(str,sep)
   sep=sep or'/'
    return str:match("(.*"..sep..")")
 end
   y = path
   
local pathMain = sc.GetMyPath()   
--  local path = wx.wxStandardPaths.Get():GetUserDataDir() .. "/SCJobCosting"
--wx.wxMkdir(path)
--local path = sc.GetMyPath()
 FilePath = path --(getPath(y,"\\"))
 --local PATH =  sc.GetMyPath() --.. "\\Files\\OperationCost.INI"  
------------------------------------------------
path5 = sc.GetMyPath()

frame = nil
evtHandler = wx.wxEvtHandler()

---------------------------------------------------------------------
--global var to hold the frame
mainframe = nil
panel = nil
m_id = 0
m_iniName = "JobCost"

function GetNextID()
    m_id = m_id+1
    return m_id
end

 ID_GENGCODE_BUT  = GetNextID()
 ID_CLOSE_BUTTON  = GetNextID()
 ID_MCedit_BUT = GetNextID()
 ID_OCedit_BUT = GetNextID()
 ID_AddMat = GetNextID()
 Id_Post = GetNextID()
 ID_Manual = GetNextID()
 
-- Handle start event - show the dialog
function OnStart(event)

end
function OnStart()

    if(mcLuaPanelParent == nil)then
        -- create the wxFrame window
        mainframe = wx.wxFrame( wx.NULL,          -- no parent
                            wx.wxID_ANY,          -- whatever for wxWindow ID
                            "SheetCam Job Costing", -- frame caption
                            
                            wx.wxDefaultPosition, wx.wxSize(1000,750) ,
	
                            wx.wxDEFAULT_FRAME_STYLE ) -- use default frame styles

        -- create a panel in the frame
        panel = wx.wxPanel(mainframe, wx.wxID_ANY)

        -- create a simple file menu with an exit
        local fileMenu = wx.wxMenu()
        fileMenu:Append(wx.wxID_EXIT, "E&xit", "Quit the wizard")

        -- create a simple help menu
        local helpMenu = wx.wxMenu()
        helpMenu:Append(wx.wxID_ABOUT, "&About", "About SheetCam Job Costing")

        
        -- create a menu bar and append the file and help menus
        local menuBar = wx.wxMenuBar()
        menuBar:Append(fileMenu, "&File")
        menuBar:Append(helpMenu, "&Help")
        
        

        -- attach the menu bar into the frame
        mainframe:SetMenuBar(menuBar)

        -- create a simple status bar
        mainframe:CreateStatusBar(1)
        mainframe:SetStatusText("No Error.")

        -- connect the selection event of the exit menu item to an
        -- event handler that closes the window
        mainframe:Connect(wx.wxID_EXIT, 
                          wx.wxEVT_COMMAND_MENU_SELECTED,
                          function (event) 
                              mainframe:Close(true) 
                          end )

        -- connect the selection event of the about menu item
        mainframe:Connect(wx.wxID_ABOUT, wx.wxEVT_COMMAND_MENU_SELECTED,
            function (event)
                 wx.wxMessageBox("SheetCam Job Costing Plugin V1.01.",
                                "About wxLua",
                                wx.wxOK + wx.wxICON_INFORMATION,
                                mainframe)
            end )
            
         

    else
        panel = mcLuaPanelParent
    end

    --Set up the main sizer so we can start adding controls
    local mainSizer = wx.wxBoxSizer(wx.wxVERTICAL)
    local InputsGridSizer  = wx.wxFlexGridSizer( 2, 4, 0, 0 )
    InputsGridSizer:AddGrowableCol(1, 0)
 
    function AddInputControl(name_string, textCtrlID)
        if(textCtrlID == nil)then
            textCtrlID = wx.wxID_ANY
        end
        
    end

    function AddSelectControl(name_string, selections, selCtrlID)
        if (selCtrlID == nil) then
            selCtrlID = wx.wxID_ANY
        end
        local staticText = wx.wxStaticText( panel, wx.wxID_ANY, name_string )
        local selCtrl   = wx.wxComboBox(panel, selCtrlID, "", wx.wxDefaultPosition, wx.wxSize(100, -1), selections)
        selCtrl:SetSelection(0)
        InputsGridSizer:Add( staticText, 0, wx.wxALIGN_CENTER_VERTICAL+wx.wxALL+wx.wxALIGN_RIGHT, 4)
        InputsGridSizer:Add( selCtrl,   0, wx.wxGROW+wx.wxALIGN_CENTER, 2)
        return selCtrl
    end
    -- Add image to the top
    path1 = sc.GetMyPath().."splash1.bmp"
    local hbmp = wx.wxBitmap(""..path1)
    --local hbmp = wx.wxBitmap("C:\\Program Files\\SheetCam TNG Development\\resources\\splash1.bmp")
    local TopImage = wx.wxStaticBitmap(panel, wx.wxID_ANY, hbmp )
    --Setup the inputs
    
    -- make the bottom buttons
    local buttonSizer = wx.wxBoxSizer( wx.wxHORIZONTAL )
    local genGcode = wx.wxButton( panel, ID_GENGCODE_BUT, "&Price Out Your Job")
    genGcode:SetBackgroundColour(wx.wxColour(217, 217, 217))

    local buttonSizer = wx.wxBoxSizer( wx.wxHORIZONTAL )
    local MCedit = wx.wxButton( panel, ID_MCedit_BUT, "&Material Cost Editor")
    MCedit:SetBackgroundColour(wx.wxColour(217, 217, 217))

    local buttonSizer = wx.wxBoxSizer( wx.wxHORIZONTAL )
    local OCedit = wx.wxButton( panel, ID_OCedit_BUT, "&Operational Cost Editor ")
    OCedit:SetBackgroundColour(wx.wxColour(217, 217, 217))



    



if (mcLuaPanelParent == nil) then
        
        buttonSizer:Add(    genGcode, 0, wx.wxALIGN_CENTER+wx.wxALL, 4 )
        buttonSizer:Add( MCedit, 0, wx.wxALIGN_CENTER+wx.wxALL, 4 )
        buttonSizer:Add( OCedit, 0, wx.wxALIGN_CENTER+wx.wxALL, 4 )
        
    end 

    --Set up the sizers
    mainSizer:Add(        TopImage, 0, wx.wxALIGN_CENTER+wx.wxALL, 2 )
    mainSizer:Add( InputsGridSizer, 0, wx.wxALIGN_CENTER+wx.wxALL, 2 )
    mainSizer:Add(     buttonSizer, 0, wx.wxALIGN_CENTER+wx.wxALL, 4 )
    panel:SetSizer( mainSizer )


-----------------------------------------------------------------------
   panel:Connect(ID_GENGCODE_BUT, wx.wxEVT_COMMAND_BUTTON_CLICKED,
    function(event)
   PST.Show()
    mainframe:Iconize(false)
   end )
   
   panel:Connect(ID_OCedit_BUT, wx.wxEVT_COMMAND_BUTTON_CLICKED,
    function(event)
   OCE.Show() 
      mainframe:Iconize(false)
   end )

     
    
   panel:Connect(ID_MCedit_BUT, wx.wxEVT_COMMAND_BUTTON_CLICKED,
    function(event)
   MCE.Show()
      mainframe:Iconize(false)
   end )

--------------------------------------------------------------------

    panel:Connect(ID_CLOSE_BUTTON, wx.wxEVT_COMMAND_BUTTON_CLICKED,
    function(event) 
        mainframe:Destroy() 
    end)

    -- Connect a handler for pressing enter in the textctrls
    panel:Connect(wx.wxID_ANY, wx.wxEVT_COMMAND_TEXT_ENTER,
    function(event)
        -- Send "fake" button press to do calculation.
        -- Button ids have been set to be -1 from textctrl ids.
      --  dialog:ProcessEvent(wx.wxCommandEvent(wx.wxEVT_COMMAND_BUTTON_CLICKED, event:GetId()-1))
    end)
    
    

    -- show the frame window
    panel:Fit()
    if (mcLuaPanelParent == nil) then
        mainframe:Fit()
        mainframe:Show(true)
    end
end




function OnFinish()
end

---------------------------------------------------------------------------
function main()
    --add a menu to the main application
    local app = sc.scApp();
    local bitmapPath = sc.GetMyPath()

    local a = _("SCJobCost") --a bit of fudgery here, these are just here for gettext.
    a = _("&ScJobCost") --gettext will add these to the catalog. TNG then reads the catalog on calls to AddMenu and SetMenuPath
 
    app:SetMenuPath("/&Plugins")
    ID_START = app:AddMenu(evtHandler,"Plugins","SCJobCost",_("Job Costing"),bitmapPath.."",sc.ITEM_NORMAL)
    app:UpdateBars() --regenerate toolbars
    evtHandler:Connect(ID_START, sc.wxEVT_ACTION, OnStart)
end

main()

dofile(pathMain .. "\\Files\\MCE.lua")
dofile(pathMain .. "\\Files\\OCE.lua")
dofile(pathMain .. "\\Files\\PST.lua")
