

-- Job Costing Plugin


MCE = {} --A convenient way to store all of the information the window/dialog creates.

--local cfg = wx.wxConfigBase.Get()
-- local a
-- local path
 --  a,path = cfg:Read("/RecentFiles/Material/Path")
 --getPath=function(str,sep)
 --  sep=sep or'/'
 --   return str:match("(.*"..sep..")")
-- end
 --  y = path
 --  pathM = (getPath(y,"\\")).."\\MaterialCost.INI"
 
-- local Path =  sc.GetMyPath() .. "\\Files\\MaterialCost.INI"
local Path = wx.wxStandardPaths.Get():GetUserDataDir() .. "/SCJobCosting"
wx.wxMkdir(Path)
print(Path)


-- create Material Cost Dialog
MCE.m_MaterialCostDialog = wx.wxDialog (wx.NULL, wx.wxID_ANY, "Material Costs", wx.wxDefaultPosition, wx.wxDefaultSize, wx.wxDEFAULT_DIALOG_STYLE )--create and name the window with desired settings
	MCE.m_MaterialCostDialog:SetSizeHints( wx.wxDefaultSize, wx.wxDefaultSize )
	MCE.bSizer4 = wx.wxBoxSizer( wx.wxVERTICAL )--create a sizer to place elements in
	MCE.m_MaterialCostGrid = wx.wxGrid( MCE.m_MaterialCostDialog, wx.wxID_ANY, wx.wxDefaultPosition, wx.wxDefaultSize, 0 )
	
	-------------------------GRID SETTINGS------------------------------------------
	-- Grid
	MCE.m_MaterialCostGrid:CreateGrid( 100, 4 )
	MCE.m_MaterialCostGrid:EnableDragGridSize( False )
	MCE.m_MaterialCostGrid:SetMargins( 0, 0 )
	
	-- Columns
	MCE.m_MaterialCostGrid:SetColSize( 0, 100 )
	MCE.m_MaterialCostGrid:SetColSize( 1, 100 )
	MCE.m_MaterialCostGrid:SetColSize( 2, 100 )
	MCE.m_MaterialCostGrid:SetColSize( 3, 200 )
	
	MCE.m_MaterialCostGrid:EnableDragColSize( True )
	MCE.m_MaterialCostGrid:SetColLabelSize( 30 )
	MCE.m_MaterialCostGrid:SetColLabelAlignment( wx.wxALIGN_CENTRE, wx.wxALIGN_CENTRE )
	
	-- Rows
	MCE.m_MaterialCostGrid:AutoSizeRows()
	MCE.m_MaterialCostGrid:EnableDragRowSize( True )
	MCE.m_MaterialCostGrid:SetRowLabelSize( 80 )
	MCE.m_MaterialCostGrid:SetRowLabelAlignment( wx.wxALIGN_CENTRE, wx.wxALIGN_CENTRE )
	
	-- Label Appearance
	
	-- Cell Defaults
	MCE.m_MaterialCostGrid:SetDefaultCellAlignment( wx.wxALIGN_LEFT, wx.wxALIGN_TOP )
	MCE.m_MaterialCostGrid:SetMinSize( wx.wxSize( 600,520 ) )
	MCE.m_MaterialCostGrid:SetMaxSize( wx.wxSize( -1,750 ) )
	-------------------------END GRID SETTINGS------------------------------------------
	
	MCE.bSizer4:Add( MCE.m_MaterialCostGrid, 0, wx.wxALL + wx.wxALIGN_CENTER_HORIZONTAL, 5 )
	
	MCE.m_sdbSizer2 = wx.wxStdDialogButtonSizer()
	MCE.m_sdbSizer2OK = wx.wxButton( MCE.m_MaterialCostDialog, wx.wxID_OK, "" )--Add an "OK" button to the bottom of the dialog.
	MCE.m_sdbSizer2:AddButton( MCE.m_sdbSizer2OK )
	MCE.m_sdbSizer2:Realize();
	
	MCE.bSizer4:Add( MCE.m_sdbSizer2, 1, wx.wxALIGN_CENTER_HORIZONTAL, 5 )
	
	
	MCE.m_MaterialCostDialog:SetSizer( MCE.bSizer4 )
	MCE.m_MaterialCostDialog:Layout()
	MCE.bSizer4:Fit( MCE.m_MaterialCostDialog )
	
	MCE.m_MaterialCostDialog:Centre( wx.wxBOTH )
	
	-- Connect Events
   -----------------------------------------------------------------------------
lastrow = 0
lastcol = 0
   
--------------------------------------------------------------------------
	MCE.m_MaterialCostGrid:Connect( wx.wxEVT_GRID_CELL_CHANGE, function(event) --This is an event handler that happens when the user changes data in a cell.
		row = event:GetRow()
        col = event:GetCol()
        event:Skip()
		--toolnum = 1 --row+1; --since tooling starts at tool 1 and row starts at 0, we have to add 1 to the row to get the correct tool.
		if(col == 0) then --update the Material Name
		Mname = (MCE.m_MaterialCostGrid:GetCellValue(row, 0))
      MatName =(MCE.m_MaterialCostGrid:GetCellValue(row, col))
         local PATH1 = Path.."\\MaterialCost.INI"
            settings = wx.wxFileConfig("","",PATH1,"",wx.wxCONFIG_USE_LOCAL_FILE)
            settings:SetPath(""..Mname)
            --to write a value
            settings:Write("Cost",MatName)
            settings:Flush()
      
      elseif(col == 1) then --update the Material Cost
		Mname = (MCE.m_MaterialCostGrid:GetCellValue(row, 0))
      Mname = (MCE.m_MaterialCostGrid:GetCellValue(row, 0))
      MatCost =(MCE.m_MaterialCostGrid:GetCellValue(row, col))
         local PATH1 = Path.."\\MaterialCost.INI"
            settings = wx.wxFileConfig("","",PATH1,"",wx.wxCONFIG_USE_LOCAL_FILE)
            settings:SetPath(""..Mname)
            --to write a value
            settings:Write("Cost",MatCost)
            settings:Flush()
      
      elseif(col == 2) then --update the Material Type
		Mname = (MCE.m_MaterialCostGrid:GetCellValue(row, 0))
      MatType =(MCE.m_MaterialCostGrid:GetCellValue(row, col))
         local PATH1 = Path .."\\MaterialCost.INI"
            settings = wx.wxFileConfig("","",PATH1,"",wx.wxCONFIG_USE_LOCAL_FILE)
            settings:SetPath(""..Mname)
            --to write a value
            settings:Write("Type",MatType)
            settings:Flush()
      
      elseif(col == 3) then --update the Material Vendor
		Mname = (MCE.m_MaterialCostGrid:GetCellValue(row, 0))
      MatVendor =(MCE.m_MaterialCostGrid:GetCellValue(row, col))
         local PATH1 = Path .."\\MaterialCost.INI" 
            settings = wx.wxFileConfig("","",PATH1,"",wx.wxCONFIG_USE_LOCAL_FILE)
            settings:SetPath(""..Mname)
            --to write a value
            settings:Write("Vendor",MatVendor)
            settings:Flush()
      end
	end )
	
	function MCE.SetupToolTable()
        MCE.m_MaterialCostGrid:SetColLabelValue(0, "Material")--Set the labels for the columns
        MCE.m_MaterialCostGrid:SetColLabelValue(1, "Cost")
        MCE.m_MaterialCostGrid:SetColLabelValue(2, "Type")
        MCE.m_MaterialCostGrid:SetColLabelValue(3, "Vendor")
       
		
 I = 0
PATH = Path .."\\MaterialCost.INI"
cfg=wx.wxFileConfig("","",PATH,"",wx.wxCONFIG_USE_LOCAL_FILE) 
found,name,index=cfg:GetFirstGroup()

  while found do
    settings= wx.wxFileConfig("","",PATH,"",wx.wxCONFIG_USE_LOCAL_FILE)
   settings:SetPath(""..name)
   a,Cost = settings:Read("Cost")
   a,Type = settings:Read("Type")
   a,Vendor = settings:Read("Vendor")
  

   returndouble = name 
 MCE.m_MaterialCostGrid:SetCellValue(I,0, tostring(returndouble))
 
 returndouble = Cost 
 MCE.m_MaterialCostGrid:SetCellValue(I,1, tostring(returndouble))
 
 returndouble = Type 
 MCE.m_MaterialCostGrid:SetCellValue(I,2, tostring(returndouble))
 
 returndouble = Vendor 
 MCE.m_MaterialCostGrid:SetCellValue(I,3, tostring(returndouble))
       
 I = (I+1)
       
  found,name,index=cfg:GetNextGroup(index)
end
end

-------------------------------------------------------------------
function MCE.Show()
MCE.SetupToolTable()
MCE.m_MaterialCostDialog:ShowModal()
mainframe:Raise()

 end   
